C
C-----------------------------------------------------------------------
C FUNCTION:  FS
C FUNCTION FOR SPECIFYING THE REQUIRED MAGNITUDE
C-----------------------------------------------------------------------
C
      FUNCTION FS(FI)
      COMMON /CM40/ FIK(10), NPK(10), NK
      COMMON /UNIT/ IND, INP, IOUTD, IOUTP, PI, SPM
C
      DO 60 K=2,NK
        K1 = K - 1
C
        IF (FI.LT.FIK(K1) .OR. FI.GE.FIK(K)) GO TO 60
C
        GO TO (10, 20, 30, 40, 50), K1
  10    FS = 1.0
        GO TO 60
  20    FS = 0.0
        GO TO 60
  30    FS = 0.0
        GO TO 60
  40    FS = 0.0
        GO TO 60
  50    FS = 0.0
  60  CONTINUE
      RETURN
      END
C
C-----------------------------------------------------------------------
C FUNCTION:  DGS
C FUNCTION FOR SPECIFYING THE REQUIRED GROUP DELAY
C-----------------------------------------------------------------------
C
      FUNCTION DGS(FI)
      COMMON /CM40/ FIK(10), NPK(10), NK
      COMMON /UNIT/ IND, INP, IOUTD, IOUTP, PI, SPM
C
      DO 60 K=2,NK
        K1 = K - 1
C
        IF (FI.LT.FIK(K1) .OR. FI.GE.FIK(K)) GO TO 60
C
        GO TO (10, 20, 30, 40, 50), K1
  10    DGS = 4.0
        GO TO 60
  20    DGS = 4.0
        GO TO 60
  30    DGS = 0.0
        GO TO 60
  40    DGS = 0.0
        GO TO 60
  50    DGS = 0.0
  60  CONTINUE
      RETURN
      END
